unit hiCallback;

interface

uses Windows, Kol, Share, Debug, Messages;

type
  THICallback = class(TDebug)
  private

  public
     _event_onKeyUp:THI_Event;
     _event_onKeyDown:THI_Event;
     _event_onShow:THI_Event;
     _event_onResize:THI_Event;
     _event_onMouseDown:THI_Event;
     _event_onMouseMove:THI_Event;
     _event_onMouseUp:THI_Event;
     _event_onMouseWheel:THI_Event;
     _event_onPaint:THI_Event;
     _event_onDblClick:THI_Event;
     _event_onSetFocus:THI_Event;
     _event_onKillFocus:THI_Event;

     _data_Handle:THI_Event;

     constructor Create;
     procedure _work_doCreateHook(var _Data:TData; Index:word);
     procedure doEvent(IdxEvent: integer);
  end;

implementation

var  p:Longint;
     Child : HWND;

function ChildCallback(HWnd: THandle; Msg: Cardinal;
             WParam, LParam: Integer): Cardinal; Stdcall;
begin
  case Msg of
    WM_LBUTTONDOWN:   THICallback(Pointer(p)).doEvent(0);
    WM_LBUTTONUP:     THICallback(Pointer(p)).doEvent(1);
    WM_LBUTTONDBLCLK: THICallback(Pointer(p)).doEvent(2);
    WM_MOUSEMOVE:     THICallback(Pointer(p)).doEvent(3);
    WM_MOUSEWHEEL:    THICallback(Pointer(p)).doEvent(4);

    WM_KEYUP:         THICallback(Pointer(p)).doEvent(5);
    WM_KEYDOWN:       THICallback(Pointer(p)).doEvent(6);

    WM_PAINT:         THICallback(Pointer(p)).doEvent(7);
    WM_SIZE:          THICallback(Pointer(p)).doEvent(8);
    WM_SETFOCUS:      THICallback(Pointer(p)).doEvent(9);
    WM_KILLFOCUS:     THICallback(Pointer(p)).doEvent(10);
    WM_SHOWWINDOW:    THICallback(Pointer(p)).doEvent(11);
    WM_CHAR:          THICallback(Pointer(p)).doEvent(12);
  end;
  Result := CallWindowProc(Pointer(GetWindowLong(HWnd, GWL_USERDATA)),
                Hwnd, Msg, WParam, LParam);
end;

constructor THICallback.Create;
begin
 p:=Longint(Self);
end;

procedure THICallback._work_doCreateHook;
begin
  Child := ReadInteger(_Data,_data_Handle);
  SetWindowLong(Child, GWL_USERDATA,
    SetWindowLong(Child, GWL_WNDPROC, LongInt(@ChildCallback)));
end;

procedure THICallback.doEvent;
begin
  case IdxEvent of
    0:  _hi_OnEvent(_event_onMouseDown, 'onMouseDown');
    1:  _hi_OnEvent(_event_onMouseUp, 'onMouseUp');
    2:  _hi_OnEvent(_event_onDblClick, 'onDblClick');
    3:  _hi_OnEvent(_event_onMouseMove, 'onMouseMove');
    4:  _hi_OnEvent(_event_onMouseWheel, 'onMouseWheel');
    5:  _hi_OnEvent(_event_onKeyUp, 'onKeyUp');
    6:  _hi_OnEvent(_event_onKeyDown, 'onKeyDown');
    7:  _hi_OnEvent(_event_onPaint, 'onPaint');
    8:  _hi_OnEvent(_event_onResize, 'onResize');
    9:  _hi_OnEvent(_event_onSetFocus, 'onSetFocus');
    10: _hi_OnEvent(_event_onKillFocus, 'onKillFocus');
    11: _hi_OnEvent(_event_onShow, 'onShow');
  end;
end;

end.
